Subject: Re: Iproute2 build broken by current kernel headers

From: Pavel Emelyanov <[email-masked]>
Date: Wed, 11 Jan 2012 10:58:51 +0400

On 01/11/2012 10:39 AM, David Miller wrote:
> From: Pavel Emelyanov <[email-masked]>
> Date: Wed, 11 Jan 2012 10:34:48 +0400
> 
>> On 01/10/2012 11:07 PM, Stephen Hemminger wrote:
>>> On Tue, 10 Jan 2012 10:54:09 -0800
>>> Stephen Hemminger <[email-masked]> wrote:
>>>
>>>> The update to inet diag broke compatibility with exported headers.
>>>> Iproute2 uses sanitized kernel headers.
>>>>
>>>> gcc -D_GNU_SOURCE -O2 -Wstrict-prototypes -Wall -I../include -DRESOLVE_HOSTNAMES -DLIBDIR=\"/usr/lib/\"   -c -o ss.o ss.c
>>>> ss.c: In function ‘tcp_show_netlink’:
>>>> ss.c:1504:7: error: ‘struct inet_diag_req’ has no member named ‘idiag_family’
>>>> make[1]: *** [ss.o] Error 1
>>>
>>> The structures need to be swapped to maintain source compatibility.
>>> inet_diag_req_compat needs to be renamed back to inet_diag_req
>>> inet_diag_req should be named something like inet_diag_req_generic
>>
>> Stephen, actually the diag modules were patched to be only binary compatible with the ss.
>> In order to make it compile with new headers I've sent the patches fixing ss, here they are:
>>
>> http://www.spinics.net/lists/netdev/msg182467.html
>> http://www.spinics.net/lists/netdev/msg182858.html
>> http://lists.openwall.net/netdev/2011/12/15/45
> 
> You can't do this Pavel, what about other userspace programs which
> might have been compiled against these headers? Any data structure
> exported to userspace is FIXED, can't you understand this?

I do understand :( But the same was done by acme@ when he generalized tcp_diag
to support dccp sockets -- he just renamed the tcp_diag_* into the inet_diag_* 
thus preserving only the binary compatibility.

> You've very much handled backwards compatability terribly in these pathces,
> I should have forced you let them cook for another full release cycle.
> :-/

Do I have 24 hours for fixing this? If I don't then just revert the whole
set, I will start this again after the current merge window closes.

Thanks,
Pavel